#include <stdio.h>
#include <stdbool.h>
#include <assert.h>
#include <time.h>

/* O(n^2) */

#define Assert assert
#define verbose false

#define MaxW 1000000000
#define MaxH 1000000000
#define MaxN 300

int Primerjaj(const void *a, const void *b) {
	return *(const int *) a - *(const int *) b; }

int UrediInOdstraniDuplikate(int *p, int n)
{
	int i, m;
	qsort(p, n, sizeof(int), &Primerjaj);
	for (i = 0, m = 0; i < n; i++)
		if (m == 0 || p[i] != p[m - 1]) p[m++] = p[i];
	return m;
}

int Najdi(int q, int *p, int n)
{
	int L = 0, D = n, M;
	while (D - L > 1) {
		M = (L + D) / 2;
		if (p[M] <= q) L = M; else D = M; }
	if (false) printf("Najdi q = %d = p[%d] = %d\n", q, L, p[L]);
	Assert(p[L] == q);
	return L;
}

typedef struct { int x1, y1, x2, y2; } Rect;

int w, h, n, y0;
int xs[3 * MaxN + 2], ys[3 * MaxN + 1], nxs, nys;
long long naj[3 * MaxN + 1]; bool prosto[3 * MaxN + 1];
Rect ast[MaxN];

bool JePotProsta(int x1, int y1, int x2, int y2)
{
	int i;
	if (y2 < y1) i = y1, y1 = y2, y2 = y1;
	if (x2 < x1) i = x1, x1 = x2, x2 = x1;
	if (ys[y1] < 0 || ys[y1] >= h) return false;
	for (i = 0; i < n; i++)
		if (x2 > ast[i].x1 && x1 < ast[i].x2 &&
			y2 > ast[i].y1 && y1 < ast[i].y2) return false;
	return true;
}

int main(int argc, char** argv)
{
	int ok_, i, ix, iy, iyPrej, x1, y1, x2, y2, smer; long long kand, *najPrej, *najZdaj;
	clock_t tm = clock();
	FILE *f = fopen(argc > 1 ? argv[1] : "asteroidi.in", "rt");
	ok_ = fscanf(f, "%d %d %d %d", &h, &w, &y0, &n);
	Assert(ok_ == 4);
	Assert(1 <= w); Assert(w <= MaxW);
	Assert(1 <= h); Assert(h <= MaxH);
	Assert(0 <= y0); Assert(y0 < h);
	Assert(1 <= n); Assert(n <= MaxN);
	for (i = 0, nxs = 0, nys = 0; i < n; i++)
	{
		ok_ = fscanf(f, "%d %d %d %d", &x1, &y1, &x2, &y2);
		Assert(ok_ == 4);
		Assert(0 <= x1); Assert(x1 <= x2); Assert(x2 < w);
		Assert(0 <= y1); Assert(y1 <= y2); Assert(y2 < h);
		x1--; y1--; x2++; y2++;
		ast[i].x1 = x1; ast[i].y1 = y1; ast[i].x2 = x2; ast[i].y2 = y2;
		xs[nxs++] = x1; xs[nxs++] = x1 + 1; xs[nxs++] = x2;
		ys[nys++] = y1; ys[nys++] = y1 + 1; ys[nys++] = y2;
	}
	fclose(f);
	xs[nxs++] = 0; xs[nxs++] = w - 1; ys[nys++] = y0;
	nxs = UrediInOdstraniDuplikate(xs, nxs);
	nys = UrediInOdstraniDuplikate(ys, nys);
	if (verbose) printf("nxs = %d, nys = %d\n", nxs, nys);
	if (verbose) { for (i = 0; i < nxs; i++) printf(" %d", xs[i]); printf("; ");
		for (i = 0; i < nys; i++) printf(" %d", ys[i]); printf("\n"); }
	for (i = 0; i < n; i++) {
		ast[i].x1 = Najdi(ast[i].x1, xs, nxs); ast[i].y1 = Najdi(ast[i].y1, ys, nys);
		ast[i].x2 = Najdi(ast[i].x2, xs, nxs); ast[i].y2 = Najdi(ast[i].y2, ys, nys); }
	if (verbose) for (i = 0; i < n; i++) printf("[%d] %d..%d x %d..%d --> %d..%d x %d..%d\n", i,
		ast[i].x1, ast[i].x2, ast[i].y1, ast[i].y2,
		xs[ast[i].x1] + 1, xs[ast[i].x2] - 1, ys[ast[i].y1] + 1, ys[ast[i].y2] - 1);

	for (iy = 0; iy < nys; iy++) naj[iy] = (ys[iy] == y0) ? 0 : -1;
	for (ix = 0; ix < nxs && xs[ix] < w; ix++)
	{
		if (xs[ix] < 0) continue;
		/* Upotevajmo premike desno. */
		for (iy = 0; iy < nys; iy++) prosto[iy] = (ys[iy] >= 0 && ys[iy] < h);
		for (i = 0; i < n; i++) if (ast[i].x1 < ix && ix < ast[i].x2)
			for (iy = ast[i].y1 + 1; iy < ast[i].y2; iy++) prosto[iy] = false;;
		if (verbose) { for (iy = 0; iy < nys; iy++) printf(" %d %s", ys[iy], prosto[iy] ? "." : "#"); printf("\n"); }
		for (iy = 0; iy < nys; iy++) if (! prosto[iy]) naj[iy] = -1;
		if (verbose) { printf("desno   ix = %d (x = %2d): ", ix, xs[ix]);
			for (iy = 0; iy < nys; iy++) printf(" %d(%d):%2d", iy, ys[iy], naj[iy]); printf("\n"); }
		/* Upotevajmo premike dol. */
		for (iy = 1; iy < nys; iy++) if (naj[iy - 1] >= 0 && prosto[iy - 1] && prosto[iy]) {
			kand = naj[iy - 1] + (ys[iy] - ys[iy - 1]);
			if (naj[iy] < 0 || kand < naj[iy]) naj[iy] = kand; }
		/* Upotevajmo premike gor. */
		for (iy = nys - 2; iy >= 0; iy--) if (naj[iy + 1] >= 0 && prosto[iy + 1] && prosto[iy]) {
			kand = naj[iy + 1] + (ys[iy + 1] - ys[iy]);
			if (naj[iy] < 0 || kand < naj[iy]) naj[iy] = kand; }
		if (verbose) { printf("gor dol ix = %d (x = %2d): ", ix, xs[ix]);
			for (iy = 0; iy < nys; iy++) printf(" %d(%d):%2d", iy, ys[iy], naj[iy]); printf("\n"); }
	}
	/* Izpiimo najbolji rezultat. */
	for (kand = -1, iy = 0; iy < nys; iy++)
		if (naj[iy] >= 0) if (kand < 0 || naj[iy] < kand) kand = naj[iy];
	printf("w = %d, h = %d, n = %d: resitev O(n^2) porabi %.3f s.\n", w, h, n, (clock() - tm) / ((double) CLOCKS_PER_SEC));
	f = fopen(argc > 2 ? argv[2] : "asteroidi.out", "wt");
	fprintf(f, "%lld\n", kand); fclose(f); return 0;
}