#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <stdbool.h>
#include <assert.h>
#include <time.h>

#define MaxM 60
#define MaxN 10000

#define verbose false
#define Assert assert

typedef uint64_t myint;

myint nizi[MaxN], naj;
int n, m;

int main(int argc, char** argv)
{
	int ok_, i, j, tren, b, a1, a2, a3, a3Goal;
	long long nTrojic, nKand, nVseh, nVsehTrue, nGoal;
	double delez;
	myint kand, kand2;
	char buf[MaxM + 3];
	bool jeNaj;
	clock_t tm; double tmSec;
	FILE *f;

	/* Preberimo n in m. */
	f = fopen((argc > 1) ? argv[1] : "xor.in", "rt");
	ok_ = fscanf(f, "%d %d\n", &n, &m);
	Assert(ok_ == 2); Assert(3 <= n); Assert(n <= MaxN);
	Assert(1 <= m); Assert(m <= MaxM);
	/* Preberimo nize. */
	for (i = 0; i < n; i++) {
		fgets(buf, sizeof(buf), f);
		nizi[i] = 0;
		for (j = 0; j < m; j++) {
			Assert(buf[j] == '0' || buf[j] == '1');
			if (buf[j] == '1') nizi[i] |= ((myint) 1) << (m - 1 - j); }
		Assert(buf[m] == 0 || buf[m] == '\n'); }
	fclose(f);

	tm = clock();
	nVseh = (long long) n; nVseh *= n; nVseh *= n; nVseh / 6;
	nGoal = 5000000000LL;
	if (nVseh > nGoal) delez = nGoal / ((double) nVseh); else delez = 1;

	nTrojic = 0; nKand = 0; naj = 0; nVsehTrue = 0;
	for (a1 = 0; a1 < n - 2; a1++) for (a2 = a1 + 1; a2 < n - 1; a2++)
	{
		nVsehTrue += (n - 1 - a2);
		kand2 = nizi[a1] ^ nizi[a2];
		a3Goal = (int) ((n - 1 - a2) * delez);
		while (a3Goal-- > 0)
		{
			a3 = a2 + 1 + (rand() % (n - 1 - a2));
			Assert(a2 < a3); Assert(a3 < n);
			kand = kand2 ^ nizi[a3];
			if (kand > naj) naj = kand, nKand = 1;
			else if (kand == naj) nKand++;
			nTrojic++;
		}
	}

	tm = clock() - tm;
	tmSec = tm / ((double) CLOCKS_PER_SEC);

	printf("n = %d, m = %d; pregledali smo %lld od %lld trojic (delez = %.2f %%, goal = %.2f %%); %lld od njih je najboljsih (%.2f %%); %.2f s = %.2f trojic na sek\n",
		n, m,
		nTrojic, nVsehTrue,
		(double) (100.0 * nTrojic / ((double) nVsehTrue)), 100.0 * delez,
		nKand, 100.0 * nKand / ((double) nTrojic),
		tmSec, nTrojic / tmSec);

	/* Izpiimo rezultate. */
	f = fopen((argc > 2) ? argv[2] : "xor.out", "wt");
	for (j = 0; j < m; j++) fputc('0' + (int) ((naj >> (m - 1 - j)) & 1), f);
	fclose(f); return 0;
}
